/// <reference types="heremaps" />
import * as Types from './types';
export declare type GeoMapDirectionServiceCreateInit = GeoMapDirectionServiceInitGoogle | GeoMapDirectionServiceInitHere;
export interface GeoMapDirectionServiceInitGoogle {
    api: Types.GoogleApi;
    type: Types.GeoMapProvider.Google;
    map: Types.GeoMapImplementation;
}
export interface GeoMapDirectionServiceInitHere {
    api: Types.HereApi;
    platform: H.service.Platform;
    type: Types.GeoMapProvider.Here;
    map: Types.GeoMapImplementation;
}
export interface GeoMapDirectionServiceInit {
    type: Types.GeoMapProvider;
    implementation: Types.GeoMapDirectionServiceImplementation;
}
export declare class GeoMapDirectionService {
    private implementation;
    static create(init: GeoMapDirectionServiceCreateInit): GeoMapDirectionService;
    private constructor();
    paintRoute(from: Types.GeoPoint, to: Types.GeoPoint): Promise<Types.GeoMapDirectionResult>;
    clear(): Promise<void>;
}
