/// <reference types="heremaps" />
import * as Types from './types';
export declare type GeoMapPlacesServiceCreateInit = GeoMapPlacesServiceInitGoogle | GeoMapPlacesServiceInitHere;
export interface GeoMapPlacesServiceInitGoogle {
    api: Types.GoogleApi;
    type: Types.GeoMapProvider.Google;
}
export interface GeoMapPlacesServiceInitHere {
    api: Types.HereApi;
    platform: H.service.Platform;
    type: Types.GeoMapProvider.Here;
    language?: string;
}
export interface GeoMapPlacesServiceInit {
    type: Types.GeoMapProvider;
    implementation: Types.GeoMapPlacesServiceImplementation;
}
export declare class GeoMapPlacesService {
    private implementation;
    static create(init: GeoMapPlacesServiceCreateInit): GeoMapPlacesService;
    private constructor();
    get(id: string): Promise<Types.Result<Types.GeoMapPlaceDetails>>;
    search(needle: string, center: Types.GeoPoint, radius: number): Promise<Types.Result<Types.GeoMapPlace[]>>;
    distanceBetween(from: Types.GeoPoint, to: Types.GeoPoint, radius?: number): number;
}
