export var AddressComponentVariant;
(function (AddressComponentVariant) {
    AddressComponentVariant[AddressComponentVariant["Long"] = 0] = "Long";
    AddressComponentVariant[AddressComponentVariant["Short"] = 1] = "Short";
})(AddressComponentVariant || (AddressComponentVariant = {}));
export function getAddressComponent(components) {
    return function (tag, options) {
        if (options === void 0) { options = { variant: AddressComponentVariant.Long }; }
        var component = components.find(function (c) { return c.types.indexOf(tag) > -1; });
        if (!component) {
            return;
        }
        switch (options.variant) {
            case AddressComponentVariant.Short:
                return component.short_name;
            case AddressComponentVariant.Long:
            default:
                return component.long_name;
        }
    };
}
//# sourceMappingURL=get-address-component.js.map