/// <reference types="heremaps" />
import * as Types from './types';
export declare type GeoMapCodingServiceCreateInit = GeoMapCodingServiceCreateInitGoogle | GeoMapCodingServiceCreateInitHere;
export interface GeoMapCodingServiceCreateInitGoogle {
    api: Types.GoogleApi;
    type: Types.GeoMapProvider.Google;
}
export interface GeoMapCodingServiceCreateInitHere {
    api: Types.HereApi;
    platform: H.service.Platform;
    type: Types.GeoMapProvider.Here;
}
export interface GeoMapCodingServiceInit {
    type: Types.GeoMapProvider;
    implementation: Types.GeoMapCodingServiceImplementation;
}
export declare class GeoMapCodingService {
    private implementation;
    static create(init: GeoMapCodingServiceCreateInit): GeoMapCodingService;
    private constructor();
    reverse(location: Types.GeoPoint): Promise<Types.Result<Types.GeoMapPlaceDetails[]>>;
}
