"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var resolvable_1 = require("./resolvable");
var types_1 = require("./types");
var GeoMapPhases = /** @class */ (function () {
    function GeoMapPhases() {
        var _a;
        this.phases = (_a = {},
            _a[types_1.GeoMapPhase.Pristine] = new resolvable_1.Resolvable(),
            _a[types_1.GeoMapPhase.Loading] = new resolvable_1.Resolvable(),
            _a[types_1.GeoMapPhase.Loaded] = new resolvable_1.Resolvable(),
            _a[types_1.GeoMapPhase.Mounting] = new resolvable_1.Resolvable(),
            _a[types_1.GeoMapPhase.Mounted] = new resolvable_1.Resolvable(),
            _a[types_1.GeoMapPhase.Layouting] = new resolvable_1.Resolvable(),
            _a[types_1.GeoMapPhase.Layouted] = new resolvable_1.Resolvable(),
            _a);
    }
    GeoMapPhases.prototype.get = function (phase) {
        return this.phases[phase];
    };
    GeoMapPhases.prototype.resolve = function (phase) {
        this.phases[phase].resolve(undefined);
    };
    return GeoMapPhases;
}());
exports.GeoMapPhases = GeoMapPhases;
//# sourceMappingURL=geo-map-phases.js.map