"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Types = require("../types");
function loadScript(src, data, context) {
    var document = context.window.document;
    return new Promise(function (resolve) {
        var script = document.createElement('script');
        script.src = src;
        Object.keys(data).map(function (key) { return script.setAttribute("data-" + key, data[key]); });
        function onLoad(event) {
            resolve({ type: Types.ResultType.Success, payload: undefined });
            script.removeEventListener('load', onLoad);
            script.removeEventListener('error', onError);
        }
        function onError(event) {
            resolve({
                type: Types.ResultType.Failure,
                error: new Error("Could not load " + src + ": " + event)
            });
            script.removeEventListener('load', onLoad);
            script.removeEventListener('error', onError);
        }
        script.addEventListener('error', onError);
        script.addEventListener('load', onLoad);
        document.body.appendChild(script);
    });
}
exports.loadScript = loadScript;
//# sourceMappingURL=load-script.js.map