"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Resolvable = /** @class */ (function () {
    function Resolvable() {
        var _this = this;
        this.promise = new Promise(function (resolve, reject) {
            _this.internalResolve = resolve;
            _this.internalReject = reject;
        });
    }
    Resolvable.prototype.resolve = function (value) {
        this.internalResolve(value);
    };
    Resolvable.prototype.reject = function (error) {
        this.internalReject(error);
    };
    Resolvable.prototype.then = function (fn) {
        return this.promise.then(fn);
    };
    return Resolvable;
}());
exports.Resolvable = Resolvable;
//# sourceMappingURL=resolvable.js.map